#include "p30f6014A.h"

#define IR_RECIEVER

#include "stdio.h"
#include "string.h"

#include "./codec/e_sound.h"
#include "./motor_led/e_init_port.h"
#include "./motor_led/advance_one_timer/e_led.h"
#include "./motor_led/advance_one_timer/e_motors.h"
#include <motor_led/advance_one_timer/e_agenda.h>
#include <camera/fast_2_timer/e_poxxxx.h>
//#include "./uart/e_uart_char.h"
#include <uart/e_uart_char.h>
#include "./a_d/advance_ad_scan/e_ad_conv.h"
#include "./a_d/advance_ad_scan/e_prox.h"
#include <a_d/advance_ad_scan/e_acc.h>
#include <a_d/advance_ad_scan/e_micro.h>
#include "math.h"

#include "memory.h"
char buffer[BUFFER_SIZE];

#ifdef IR_RECIEVER
#include <motor_led/advance_one_timer/e_remote_control.h>
#define SPEED_IR 600
#endif 
#include "runaccelerometer.h"
#include "runbreitenberg_adv.h"
#include "runlocatesound.h"
#include "runwallfollow.h"
#include "rungrounddirection.h"
#include "utility.h"
#include "Asercom.h"
#include "runshow.h"
#include "translatorI2C.h"

#define PI 3.14159265358979

int main() {
	int selector;
	char c;

	//system initialization 
	e_init_port();    // configure port pins
	e_start_agendas_processing();
	e_init_motors();
	e_init_uart1();   // initialize UART to 115200 Kbaud
	//e_init_uart2();   // initialize UART to 115200 Kbaud
	e_init_ad_scan(ALL_ADC);
	//e_init_ad_scan();

	//Reset if Power on (some problem for few robots)
	if (RCONbits.POR) {
		RCONbits.POR=0;
		__asm__ volatile ("reset");
	}

	// Decide upon program
	selector=getselector();
	sprintf(buffer, "Selector pos %d\r\n", selector);
	e_send_uart1_char(buffer, strlen(buffer));
	//e_send_uart2_char(buffer, strlen(buffer));
	if (selector==0) {
		run_accelerometer();
	} else if (selector==1) {
		run_locatesound();
	} else if (selector==2) {
		run_wallfollow();
	} else if (selector==3) {
		run_asercom();		// advanced sercom protocol
	} else if (selector==5) {	// sensor "feedback display"
		run_SensDispl();
	} else if (selector==6) {	// camera point to light
		run_CameraTurn();
	} else if (selector==7) {	// act like the ASL RS232 - I2C translator
		run_translatorI2C();
	} else if (selector==8) {	
		run_grounddirection();
	} else if (selector==13) {	// uart 1 to uart 2 transponder
		e_init_uart2();// 230400   // initialize UART to 115200 Kbaud
		e_send_uart2_char(buffer, strlen(buffer));
		while (1) {
			if(e_getchar_uart1(&c)) e_send_uart2_char(&c, 1);
			if(e_getchar_uart2(&c)) e_send_uart1_char(&c, 1);
		}
	} else if (selector==14) {
		run_breitenberg_follower();
	} else if (selector==15) {	// simple dust cleaner behaviour
		run_DustCleaner();
	} else {
		run_breitenberg_shocker();
	}

	while(1);
	return 0;
}

